# class Crystal::Macros::ProcLiteral

- Crystal::Macros::ProcLiteral
- Crystal::Macros::ASTNode

##
Overview

A proc method, written like:

    ->(arg : String) {
      puts arg
    }

##
Defined in:

compiler/crystal/macros.cr

##
Instance Method Summary

- #args : ArrayLiteral(Arg)

  Returns the arguments of this proc.

- #body : ASTNode

  Returns the body of this proc.

- #return_type : ASTNode | Nop

  Returns the return type of this proc, if specified.

### Instance methods inherited from class `Crystal::Macros::ASTNode`

!=(other : ASTNode) : BoolLiteral !=, ==(other : ASTNode) : BoolLiteral ==, class_name : StringLiteral class_name, column_number : StringLiteral | NilLiteral column_number, doc : StringLiteral doc, doc_comment : MacroId doc_comment, end_column_number : StringLiteral | NilLiteral end_column_number, end_line_number : StringLiteral | NilLiteral end_line_number, filename : StringLiteral | NilLiteral filename, id : MacroId id, is_a?(type : TypeNode) : BoolLiteral is_a?, line_number : StringLiteral | NilLiteral line_number, nil? : BoolLiteral nil?, raise(message) : NoReturn raise, stringify : StringLiteral stringify, symbolize : SymbolLiteral symbolize, warning(message : StringLiteral) : NilLiteral warning

##
Instance Method Detail

def args : ArrayLiteral(Arg) #

Returns the arguments of this proc.

def body : ASTNode #

Returns the body of this proc.

def return_type : ASTNode | Nop #

Returns the return type of this proc, if specified.